
local Server = Game:addState('Server')

function Server:enterState()
  print("initializing server")

  self.connections = 0
  self.receptions = 0
  self.disconnections = 0

  local function onConnect(ip, port)
    self.connections = self.connections + 1
    print("Connection from " .. tostring(ip) .. ':' .. tostring(port))
  end

  local function onReceive(data, ip, port)
    self.receptions = self.receptions + 1
    print("Receiving from " .. tostring(ip) .. ':' .. tostring(port) .. ': ' .. tostring(data))
  end

  local function onDisconnect(ip, port)
    self.disconnections = self.disconnections + 1
    print("Disconnect from " .. tostring(ip) .. ':' .. tostring(port))
  end

  self.lube_server = lube.server(18025)
  self.lube_server:setCallback(onReceive, onConnect, onDisconnect)
  self.lube_server:setHandshake("Hi!")
  print("initialized server")
end

function Server:update(dt)
  self.lube_server:update(dt)
end

function Server:draw()
  love.graphics.print('Connections: '  .. tostring(self.connections) .. 
                      '  Receptions: ' .. tostring(self.receptions) ..
                      '  Disconnections: ' .. tostring(self.disconnections), 0,0)  
end
                                                                                          
function Server.keypressed(k)
  if k=='escape' then
    self:gotoState('Menu')
  end
end

function Server:exitState()
  print("Exiting server")
  lube.server.socket:close()
  self.lube_server = nil
end
